#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/time.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <stdbool.h>
#include <unistd.h>
#include "LibTestMain.h"
#include "aratek.h"

typedef void *HANDLE ;
#define FEATURELEN (20 *1024)
HANDLE nhandle1 = NULL;
int width,height,dpi;
#define ENROLL_CNT 3
#define IMAGEQUALITY_THRESHOLD 45
#define ENROLL_RETRYCNT   100

#define IMAGEQUALITY_BAD_CODE 3
unsigned char tempBuf[FEATURELEN * ENROLL_CNT];
unsigned char featureBuf[FEATURELEN];

//注：如果调用了CVR_InitComm成功打开设备，程序结束前一定要调用CVR_CloseComm()函数，否则下次执行程序将会出错
void my_handler(int s)
{
	usleep(100000);
	printf("Caught signal %d, call CVR_CloseComm()\n",s);
	//CVR_CloseComm();
	int iRet = CVR_CloseComm();
	if(iRet != 1)
	{
		printf("CVR_CloseComm failed, Ret = %d\n", iRet);
	}
	usleep(100000);		//延时100ms 等待系统内部释放资源完成
	exit(0); 
}


int init()
{
	int ret = ARAFPSCAN_GlobalInit();
	if(ret!=0)
	{
		return ret;
	}
	ret = ARAFPSCAN_OpenDevice(&nhandle1,0);
	if(ret!=0)
	{
		return ret;
	}
	ret = ARAFPSCAN_GetImageInfo(nhandle1,&width,&height,&dpi);
	return ret;
}

int quit()
{
	int ret = ARAFPSCAN_CloseDevice(&nhandle1);
	if(ret != 0)
	{
		return ret;
	}
	ret = ARAFPSCAN_GlobalFree();
	if(ret!=0)
	{
		return ret;
	}
	return ret;
}

int extractfeature(unsigned char *fea)
{
	int score = 0;
	unsigned char *rawdata=(unsigned char *)malloc(400*300);
	printf("Please press your finger...\n");
	usleep(1000000);
	int ret = ARAFPSCAN_CaptureRawData(nhandle1, 0, rawdata);
	if(ret != 0)
	{
		printf("\n error = %d", ret);
		free(rawdata);
		return ret;
	}
	ARAFPSCAN_ImgQuality(width, height, rawdata, &score);
	printf("指纹 score = %d\n", score);
	if(score < IMAGEQUALITY_THRESHOLD)
	{
		free(rawdata);
		return IMAGEQUALITY_BAD_CODE;
	}
	ret = ARAFPSCAN_ExtractFeature(nhandle1, 0, fea);
	free(rawdata);
	return ret;
}


//接口测试
int main()
{
	struct sigaction sigIntHandler;

	sigIntHandler.sa_handler = my_handler;
	sigemptyset(&sigIntHandler.sa_mask);
	sigIntHandler.sa_flags = 0;
	
	sigaction(SIGINT, &sigIntHandler, NULL);

	int iRet = CVR_InitComm(NULL, 2); //USB-OTG
	if(iRet != 1)
	{
		printf("CVR_InitComm failed, Ret = %d\n", iRet);
		return -1;
	}
	
	usleep(1000000);
	
	//读设备状态
	iRet = CVR_GetStatus();
	if(iRet != 1)
	{
		printf("CVR_GetStatus failed, Ret = %d\n", iRet);
		CVR_CloseComm();
		return -1;
	}
	printf("Device Status: OK\n");

	//读安全模块号
	char strTemp[256] = {0x00};
	int strTempLen = sizeof(strTemp);
	iRet = CVR_GetSAMID(strTemp, &strTempLen);
	if(iRet != 1)
	{
		printf("CVR_GetSAMID failed, Ret = %d\n", iRet);
	}
	else
	{	
		printf("SAMID:%s\n", strTemp);
	}
	
	bool bTerminate = false;
	struct timeval timeStart;
	struct timeval timeEnd; 


		usleep(300000);

		gettimeofday(&timeStart, NULL);
		
		//卡认证
		iRet = CVR_Authenticate();
		if(iRet != 1)
		{
			printf("Authenticate failed, Ret = %d\n", iRet);
		}


		//读卡
		iRet = CVR_Read_FPContent(7);
		if(iRet != 1)
		{
			printf("Read_FPContent failed, Ret = %d\n", iRet);
		}
		gettimeofday(&timeEnd, NULL);
		int iTime;
		iTime = 1000 * (timeEnd.tv_sec - timeStart.tv_sec) + (timeEnd.tv_usec - timeStart.tv_usec)/1000;
		printf("read card time : %d ms\n", iTime);

		//获取卡类型
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetCertType((unsigned char*)strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetCertType failed, Ret = %d\n", iRet);			
		}
		printf("Card Type:%d\n", strTemp[0]);

		//获取姓名
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleName(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleName failed, Ret = %d\n", iRet);
		}
		printf("People Name:%s\n", strTemp);

		//获取性别
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleSex(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleSex failed, Ret = %d\n", iRet);
		}
		printf("People Sex:%s\n", strTemp);
		
		//获取民族/国家地区
		strTempLen = sizeof(strTemp);
		memset(strTemp, 0, strTempLen);
		iRet = GetPeopleNation(strTemp, &strTempLen);
		if(iRet != 1)
		{
			printf("GetPeopleNation failed, Ret = %d\n", iRet);
		}
		printf("People Nation:%s\n", strTemp);

		//获取头像照片
		unsigned char arrPhotoData[38862];
		int iPhotoDataLen = sizeof(arrPhotoData);
		iRet = GetBMPData(arrPhotoData, &iPhotoDataLen);
		if(iRet != 1)
		{
			printf("GetBMPData failed, Ret = %d\n", iRet);
		}
		
		FILE* fp_photo = fopen("./LibTestMainPhoto.bmp","wb+");
		if(fp_photo == NULL)
		{
			printf(" write  Photo error\n");
			return -1;
		}
		fwrite(arrPhotoData, 1, iPhotoDataLen, fp_photo);
		fclose(fp_photo);

	unsigned char fpData[38862];
	int ifpDataLen = sizeof(fpData);
	iRet = GetFPDate(fpData, &ifpDataLen);
	printf("fplen= %d\n", ifpDataLen);
	FILE* fp_dat = fopen("./fp.dat","wb+");
	if(fp_dat == NULL)		{
		printf(" write  fp error\n");
		return -1;
	}
	fwrite(fpData, 1, ifpDataLen, fp_dat);
	fclose(fp_dat);

	iRet = CVR_CloseComm();
	if(iRet != 1)
	{
		printf("CVR_CloseComm failed, Ret = %d\n", iRet);
	}
	printf("CVR_CloseComm OK\n");

    int ret = init();
	if(ret != 0)
	{
		printf("Initialization failed.\n");
		printf("ErrorCode:%d \n",ret);
		return 0;
	}

	int score = 0, pResult = 0;
	memset(featureBuf, 0, FEATURELEN);
	printf("采集第一枚指纹\n");
	usleep(3000000);
	ret = extractfeature(featureBuf);
	memcpy(tempBuf, featureBuf, FEATURELEN);
	printf("采集第二枚指纹\n");
	usleep(3000000);
	ret = extractfeature(featureBuf);
	ARAFPSCAN_VerifyExt(nhandle1, 1, featureBuf, ENROLL_CNT, tempBuf, &score, &pResult);
	printf("比对结果：\n score = %d, pResult = %d\n", score, pResult);
	if(pResult  == 0){
		printf("两枚指纹一样\n");
	}	else {
		printf("两枚指纹不一样\n");	
	}
	quit();

	return 0;
}


